<?php

function set_devices() {
    global $conf, $db;

    $files=array();
    $files['/etc/asterisk/pjsip.conf']='PJSIP';
    $files['/etc/asterisk/sip.conf']='SIP';
    $files['/etc/asterisk/iax.conf']='IAX2';

    foreach($files as $file=>$tech) {
        if(!is_readable($file)) { continue; }
        $lines = file($file);
        $channel='';
        $extenlist = array();
        $trunkcount=0;
        foreach($lines as $line) {
            $line=trim($line);
            if(preg_match("/^\[/",$line)) {
                if(isset($data['channel'])) {
                    if(isset($data['callerid'])) {
                        $data['type']='extension';
                    } else {
                        $trunkcount++;
                        $data['type']='trunk';
                    }
                    if(!isset($extenlist[$data['channel']])) {
                        $extenlist[$data['channel']] = $data;
                    }
                }
                preg_match("/\[([^]]*)].*/",$line,$matches);
                $channel = $matches[1];
                $data = array();
                $data['channel']="$tech/".$channel;
            } else {
                if($channel<>'') {
                    $partes = preg_split("/=/",$line);
                    $param = $partes[0];
                    $value = isset($partes[1])?trim($partes[1]):'';
                    if($param=='callerid') {
                        $partes = preg_split("/ </",$value);
                        $name = $partes[0];
                        $exten = isset($partes[1])?$partes[1]:$channel;
                        $exten = preg_replace("/>/","",$exten);
                        $data['callerid'] = $value;
                        $data['name'] = $name;
                        $data['exten'] = $exten;
                    }
                }
            }
        }
        // last item
        if(isset($data['callerid'])) {
            $data['type']='extension';
        } else {
            $data['type']='trunk';
        }
        $extenlist[$data['channel']] = $data;
        foreach($extenlist as $channel=>$mydata) {
            if($mydata['type']=='extension') {
                $query = "INSERT INTO acdrchannels (channel,name,extension) VALUES ('%s','%s','%s') ON DUPLICATE KEY UPDATE name='%s'";
                $db->consulta($query,array($channel,$mydata['name'],$mydata['exten'],$mydata['name']));
            }
        }
    }
    $query = "INSERT INTO acdrchannels (channel,name) values ('-1','ALL') ON DUPLICATE KEY UPDATE name='ALL'";
    $db->consulta($query);
}
